unit UCODFIS;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls;

type
  TMain = class(TForm)
    CF: TEdit;
    Kllo: TButton;
    Label1: TLabel;
    SB: TStatusBar;
    procedure KlloClick(Sender: TObject);
  private
    { Private declarations }
  public
    FUNCTION ControlloCF(codice:string; Var Mess:string):boolean;
    FUNCTION ControlloPI(codice:string; Var Mess:string):boolean;
    { Public declarations }
  end;

var
  Main: TMain;
const
TabConv1: string[36] = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
TabConv2: array [1..36] of integer = ( 1, 0, 5, 7, 9,13,15,17,19,21,
                                       2, 4,18,20,11, 3, 6, 8,12,14,
                                      16,10,22,25,24,23, 1, 0, 5, 7,
                                       9,13,15,17,19,21);

TabConv3: array [1..36] of integer = ( 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
                                      10,11,12,13,14,15,16,17,18,19,
                                      20,21,22,23,24,25, 0, 1, 2, 3,
                                       4, 5, 6, 7, 8, 9);

TabRest : string[26] = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
implementation

{$R *.DFM}

procedure TMain.KlloClick(Sender: TObject);
var i,k:cardinal;
    messaggio:string;
    valido,numerico:Boolean;
//    chkdgt:char;
begin
messaggio:=cf.text;
numerico:=true;
for i:= 1 to length(CF.text) do
    if not(cf.text[i] in ['0'..'9']) then numerico:=false;

if (length(CF.text) = 11) and (numerico) then
    valido:=ControlloPI(CF.text,messaggio)
else
    valido:=ControlloCF(CF.text,messaggio);

sb.simpletext:=messaggio;

end;

FUNCTION TMain.ControlloCF(codice:string; Var Mess:string):boolean;
var
  i,j:integer;
  totale:integer;
begin
IF length(codice) < 16 then
   begin
     Mess:='Lunghezza insufficiente';
     result:=false;
     exit;
   end;

totale:=0;
for i:= 1 to 15 do
    begin
      j:=pos(codice[i],tabconv1);
      if j = 0 then
         begin
           mess:='Carattere '+codice[i]+' in pos. '+inttostr(i)+' sconosciuto';
           result:=false;
           exit;
         end;
       if odd(i) then
          totale:=totale+tabconv2[j]
       else
          totale:=totale+tabconv3[j];
    end;

    if  codice[16] <> tabrest[totale mod 26 +1] then begin
       Mess:='Codice Errato';
       Result:=False;
       end
    else begin
       Mess:='Codice formalmente corretto';
       Result:=true;
       end;
end;

FUNCTION TMain.ControlloPi(codice:string; Var Mess:string):boolean;
var
  i:integer;
  w:integer;
  totale:integer;
begin
totale:=0;
i:=1;
repeat
  totale:=totale+strtoint(codice[i]);
  inc(i,2);
until i > 9;

i:=2;
repeat
  w:=strtoint(codice[i]) * 2;
  if w > 9 then
       w:= (w div 10)+ (w mod 10);

  totale:=totale+w;
  inc(i,2);
until i > 10;

w:= 10 - (totale mod 10);
w:= (w mod 10);
if codice[11] <> inttostr(w) then
   begin
     mess:='Partita Iva errata';
     result:=false;
   end else begin
     mess:='Partita Iva corretta';
     result:=true;
   end;  
end;

end.
